/*
 * Copyright (c) 2005 DocJava, Inc. All Rights Reserved.
 */
package gui.run;

import gui.ClosableJFrame;
import ip.color.Yiq;
import ip.color.Yuv;

import javax.swing.*;
import javax.vecmath.Matrix3d;
import java.awt.*;


public abstract class RunColor3dPanel extends
        JPanel implements
        Runnable {
    Matrix3d m3d = new Matrix3d();

    public Matrix3d getValue() {
        return m3d;
    }


    public RunColor3dPanel() {
        setLayout(new BorderLayout());
        JTabbedPane tabbedPane = new JTabbedPane();
        tabbedPane.addTab("3dMatrix", new RunMatrix3dPanel() {
            public void run() {
                RunColor3dPanel.this.m3d = getValue();
                RunColor3dPanel.this.run();
            }
        });
        tabbedPane.addTab("color space", new ButtonControlPanel() {
            public void run() {
                RunColor3dPanel.this.m3d = getValue();
                RunColor3dPanel.this.run();
            }
        });

        add(BorderLayout.CENTER, tabbedPane);

    }

    private abstract class ButtonControlPanel extends JPanel implements Runnable {
        private Matrix3d m3d = new Matrix3d();
        private ButtonGroup bg = new ButtonGroup();

        public Matrix3d getValue() {
            return m3d;
        }

        ButtonControlPanel() {
            setLayout(new FlowLayout());
            addRadioButton(new RunRadio("rgb2yuv") {
                public void run() {
                    m3d = Yuv.getRgb2yuvMat().getMatrix3d();
                    ButtonControlPanel.this.run();
                }
            });
            addRadioButton(new RunRadio("rgb2iyq") {
                public void run() {
                    m3d = Yiq.getRgbn2yiqMat().getMatrix3d();
                    ButtonControlPanel.this.run();
                }
            });
        }


        public void addRadioButton(RunRadio rr) {
            add(rr);
            bg.add(rr);
        }

    }

    public static void main(String[] args) {

        ClosableJFrame cf = new ClosableJFrame();
        Container c = cf.getContentPane();
        final Matrix3dView view = new Matrix3dView();
        c.add(new RunColor3dPanel() {
            public void run() {
                Matrix3d value = getValue();
                System.out.println(value);
                view.updateView(value);
            }
        });

        c.add(view);
        c.setLayout(new FlowLayout());
        cf.setSize(400, 400);
        cf.setVisible(true);

    }


}
