package j3d.polyViewer.vec3;

import ip.transforms.Kernels;

/**
 * Created by IntelliJ IDEA.
 * User: dlee
 * Date: Apr 12, 2005
 * Time: 2:15:53 PM
 * To change this template use File | Settings | File Templates.
 */

public class RealEllipticalCylinderInterface implements Vec3FunctionInterface {
    public static final double sqrt_2 = Math.sqrt(2);
    public static final double pi = Math.PI;
    public static final double twoPi = Math.PI * 2;

    public RealEllipticalCylinderInterface() {

    }

    // Real elliptic cylinder x/a+y/b=1
    public Vec3 getPolarVec3(double r1,
                             double theta1,
                             double r2,
                             double theta2) {
        double a = r1, b = r1, x, y = 1;
        x = a * (1 - (y / b));
        y = b * (1 - (x / a));

        double z = Kernels.gauss(x, y, 0, 0, r2);
        double scale = twoPi * r2 * r2;
        z = z * scale;
        return new Vec3((float) x,
                (float) y,
                (float) z);
    }

    public static final double sin(double theta) {
        return Math.sin(theta);
    }

    public static final double cos(double theta) {
        return Math.cos(theta);
    }

    public String toString() {
        return getClass().getName();
    }

}



